
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>设计模式 ( 二十 )： Template method模板方法模式 -- 行为型 / 憋错料</title>

    <meta name="description" content="设计模式 ( 二十 )： Template method模板方法模式 -- 行为型   1.概述 在面向对象开发过程中,通常我们会遇到这样的一个问题:我们知道一个算法所需的关键步骤,并确定了这些步骤的执行顺序.但是某些步骤的具体实现是未知的,或者说某些步骤的实现与具体的环境相关.例子1:银行业务办理流程在银行办理业务时,一般都包含几个基本固定步骤:取号排队-&gt;办理具体业务-&gt;对银行工作人员进行评分.取号取号排队和对银行工作人员进行评分业务逻辑是一样的.但是办理具体业务是个不相同的,具体业务可能取款.存款或者转账. 2.问题 如何保证架构逻辑的正常执行,而不被子类破坏 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">设计模式 ( 二十 )： Template method模板方法模式 -- 行为型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>&nbsp;</strong></p>
<p><strong>1.概述</strong></p>
<blockquote><p>在面向对象开发过程中，通常我们会遇到这样的一个问题：我们知道一个算法所需的关键步骤，并确定了这些步骤的执行顺序。但是某些步骤的具体实现是未知的，或者说某些步骤的实现与具体的环境相关。<br />例子1：银行业务办理流程<br />在银行办理业务时，一般都包含几个基本固定步骤:<br />取号排队-&gt;办理具体业务-&gt;对银行工作人员进行评分。<br />取号取号排队和对银行工作人员进行评分业务逻辑是一样的。但是办理具体业务是个不相同的，具体业务可能取款、存款或者转账。</p></blockquote>
<p><strong>2.问题</strong></p>
<blockquote><p>如何保证架构逻辑的正常执行，而不被子类破坏&nbsp;？</p></blockquote>
<p><strong>3.解决方案</strong></p>
<blockquote><p>模板方法：定义一个操作中的算法的骨架，而将一些步骤延迟到子类中。 T模板方法使得子类可以不改变一个算法的结构即可重定义该算法的某些特定步骤。（Template Method Pattern:Definethe skeleton of an algorithm&nbsp;in an operation,deferring some steps tosubclasses.Template Methodletssubclasses redefine certain steps&nbsp;of an algorithmwithoutchanging the algorithm‘s structure.&nbsp;）</p>
<p>1）模板方法模式是基于继承的代码复用基本技术，模板方法模式的结构和用法也是面向对象设计的核心之一。在模板方法模式中，可以将相同的代码放在父类中，而将不同的方法实现放在不同的子类中。</p>
<p>2）在模板方法模式中，我们需要准备一个抽象类，将部分逻辑以具体方法以及具体构造函数的形式实现，然后声明一些抽象方法来让子类实现剩余的逻辑。不同的子类可以以不同的方式实现这些抽象方法，从而对剩余的逻辑有不同的实现，这就是模板方法模式的用意。模板方法模式体现了面向对象的诸多重要思想，是一种使用频率较高的模式。</p></blockquote>
<p><strong>4.适用性</strong></p>
<blockquote><p>模板方法应用于下列情况：<br />&bull; 1） 一次性实现一个算法的不变的部分，并将可变的行为留给子类来实现。<br />&bull; 2）各子类中公共的行为应被提取出来并集中到一个公共父类中以避免代码重复。首先识别现有代码中的不同之处，并且将不同之处分离为新的操作。最后，用一个调用这些新的操作的模板方法来替换这些不同的代码。<br />&bull; 3）控制子类扩展。模板方法只在特定点调用&ldquo; hook&rdquo;操作 ，这样就只允许在这些点进行扩展。</p></blockquote>
<p><strong>5.结构</strong></p>
<blockquote><p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbXkuY3Nkbi5uZXQvdXBsb2Fkcy8yMDEyMDUvMTQvMTMzNjk2NTA5M18xMDQ4LmpwZw==.jpg" /></p></blockquote>
<p><strong>6.模式的组成</strong></p>
<blockquote><p>抽象类（AbstractClass）:&nbsp;定义抽象的原语操作（primitive operation） ，具体的子类将重定义它们以实现一个算法， 实现一个模板方法,定义一个算法的骨架。该模板方法不仅调用原语操作，也调用定义<br />
具体子类 （ConcreteClass）: &nbsp;实现原语操作以完成算法中与特定子类相关的步骤。</p></blockquote>
<p>7.效果</p>
<blockquote>
<p><strong>模板方法模式的优点：</strong><br />1)模板方法模式在一个类中形式化地定义算法，而由它的子类实现细节的处理。<br />2)模板方法是一种代码复用的基本技术。它们在类库中尤为重要，它们提取了类库中的公共行为。<br />3)模板方法模式导致一种反向的控制结构，这种结构有时被称为&ldquo;好莱坞法则&rdquo; ，即&ldquo;别找我们，,我们找你&rdquo;通过一个父类调用其子类的操作(而不是相反的子类调用父类)，通过对子类的扩展增加新的行为，符合&ldquo;开闭原则&rdquo;</p>
<p><strong>模板方法模式的缺点:</strong><br />每个不同的实现都需要定义一个子类，这会导致类的个数增加，系统更加庞大，设计也更加抽象，但是更加符合&ldquo;单一职责原则&rdquo;，使得类的内聚性得以提高。</p></blockquote>
<p><strong>8.实现</strong></p>
<blockquote><p>我们使用银行业务实现，添加了hook方法，客户自己觉得评价服务。</p>
<ol>
<li>&lt;?php</li>
<li>/**</li>
<li>*&nbsp;模板方法模式：</li>
<li>*</li>
<li>*&nbsp;@author&nbsp;guisu</li>
<li>*/</li>
<li>/**</li>
<li>*&nbsp;抽象类</li>
<li>*/</li>
<li>abstract&nbsp;class&nbsp;AbstractBank</li>
<li>{</li>
<li>private&nbsp;$_number&nbsp;;</li>
<li>/**</li>
<li>*模板方法</li>
<li>*&nbsp;因为子类不能覆写一个被定义为final的方法。从而保证了子类的逻辑永远由父类所控制。</li>
<li>*</li>
<li>*/</li>
<li>public&nbsp;final&nbsp;&nbsp;&nbsp;function&nbsp;templateMethodProcess()</li>
<li>{</li>
<li>$this-&gt;takeNumber();</li>
<li>$this-&gt;transact();</li>
<li>if($this-&gt;isEvaluateHook())&nbsp;{</li>
<li>$this-&gt;evaluateHook();</li>
<li>}</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;基本方法&mdash;具体方法</li>
<li>*&nbsp;取号</li>
<li>*</li>
<li>*/</li>
<li>private&nbsp;&nbsp;function&nbsp;takeNumber()</li>
<li>{</li>
<li>return&nbsp;++$this-&gt;_number;</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;&nbsp;//基本方法&mdash;抽象方法</li>
<li>*</li>
<li>*/</li>
<li>protected&nbsp;&nbsp;abstract&nbsp;function&nbsp;transact();</li>
<li>/**</li>
<li>*&nbsp;基本方法&mdash;钩子方法</li>
<li>*</li>
<li>*/</li>
<li>protected&nbsp;function&nbsp;evaluateHook()&nbsp;{</li>
<li>echo&nbsp;‘&nbsp;evaluateHook&lt;br/&gt;‘;</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;基本方法&mdash;钩子方法</li>
<li>*/</li>
<li>protected&nbsp;function&nbsp;isEvaluateHook()&nbsp;{</li>
<li>return&nbsp;true;</li>
<li>}</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;具体子类:存款</li>
<li>*/</li>
<li>class&nbsp;ConcreteDeposit&nbsp;extends&nbsp;AbstractBank</li>
<li>{</li>
<li>public&nbsp;function&nbsp;transact()&nbsp;{</li>
<li>//实现代码</li>
<li>echo&nbsp;‘Deposit‘,&nbsp;‘&lt;br&gt;‘;</li>
<li>}</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;具体子类:取款</li>
<li>*/</li>
<li>class&nbsp;ConcreteWithdraw&nbsp;extends&nbsp;AbstractBank</li>
<li>{</li>
<li>public&nbsp;function&nbsp;transact()&nbsp;{</li>
<li>//实现代码</li>
<li>echo&nbsp;‘Withdraw‘,&nbsp;‘&lt;br&gt;‘;</li>
<li>}</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;具体子类:转账</li>
<li>*/</li>
<li>class&nbsp;ConcreteTrancfer&nbsp;extends&nbsp;AbstractBank</li>
<li>{</li>
<li>public&nbsp;function&nbsp;transact()&nbsp;{</li>
<li>//实现代码</li>
<li>echo&nbsp;‘Trancfer‘,&nbsp;‘&lt;br&gt;‘;</li>
<li>}</li>
<li>}</li>
<li>$c&nbsp;=&nbsp;new&nbsp;&nbsp;ConcreteTrancfer();</li>
<li>$c-&gt;templateMethodProcess();</li>
</ol>
</blockquote>
<p><strong>9.与其他相关模式</strong></p>
<blockquote><p>1）策略模式：模板方法使用继承来改变算法的一部分。 Strategy使用委托来改变整个算法。模板方法模式与策略模式的作用十分类似，有时可以用策略模式替代模板方法模式。模板方法模式通过继承来实现代码复用，而策略模式使用委托，把不确定的行为集中到一个接口中，并在主类委托这个接口。委托比继承具有更大的灵活性。</p></blockquote>
<p><strong>10.模式的扩展</strong></p>
<blockquote><p>1）模板方法模式与控制反转（好莱坞原则）在模板方法模式中，子类不显式调用父类的方法，而是通过覆盖父类的方法来实现某些具体的业务逻辑，父类控制对子类的调用，这种机制被称为好莱坞原则(Hollywood Principle)，好莱坞原则的定义为：&ldquo;不要给我们打电话，我们会给你打电话(Don&lsquo;t call us, we&rsquo;ll call you)&rdquo;。在好莱坞，把简历递交给演艺公司后就只有回家等待。由演艺公司对整个娱乐项的完全控制，演员只能被动式的接受公司的差使,在需要的环节中，完成自己的演出。模板方法模式充分的体现了&ldquo;好莱坞&rdquo;原则。由父类完全控制着子类的逻辑，子类不需要调用父类，而通过父类来调用子类，子类可以实现父类的可变部份，却继承父类的逻辑,不能改变业务逻辑。</p>
<p>2）模板方法模式符合开闭原则</p>
<p>模板方法模式意图是由抽象父类控制顶级逻辑，并把基本操作的实现推迟到子类去实现,这是通过继承的手段来达到对象的复用，同时也遵守了开闭原则。</p>
<p>父类通过顶级逻辑，它通过定义并提供一个具体方法来实现，我们也称之为模板方法。通常这个模板方法才是外部对象最关心的方法。在上面的银行业务处理例子中，<strong>templateMethodProcess</strong>这个方法才是外部对象最关心的方法。所以它必须是public的,才能被外部对象所调用。</p>
<p>子类需要继承父类去扩展父类的基本方法，但是它也可以覆写父类的方法。如果子类去覆写了父类的模板方法，从而改变了父类控制的顶级逻辑，这违反了&ldquo;开闭原则&rdquo;。我们在使用模板方法模式时，应该总是保证子类有正确的逻辑。所以模板方法应该定义为final的。所以AbstractClass类的模板方法templateMethodProcess方法应该定义为final。</p>
<p>模板方法模式中,抽象类的模板方法应该声明为final的。因为子类不能覆写一个被定义为final的方法。从而保证了子类的逻辑永远由父类所控制。</p></blockquote>
<blockquote><p>3）模板方法模式与对象的封装性</p></blockquote>
<blockquote><p>面向对象的三大特性：继承，封装，多态。</p>
<p>对象有内部状态和外部的行为。封装是为了信息隐藏，通过封装来维护对象内部数据的完整性。使得外部对象不能够直接访问一个对象的内部状态，而必须通过恰当的方法才能访问。</p>
<p>对象属性和方法赋予指定的修改符(public、protected、private)来达到封装的目的，使得数据不被外部对象恶意的访问及方法不被错误调用导造成破坏对象的封装性。</p>
<p>降低方法的访问级别，也就是最大化的降低方法的可见度是一种很重要的封装手段。最大化降低方法的可见度除了可以达到信息隐藏外，还能有效的降低类之间的耦合度,降低一个类的复杂度。还可以减少开发人员发生的的错误调用。</p>
<p>一个类应该只公开外部需要调用的方法。而所有为public方法服务的方法都应该声明为protected或private。如是一个方法不是需要对外公开的，但是它需要被子类进行扩展的或调用。那么把它定义为protected.否则应该为private。</p>
<p>显而易见，模板方法模式中的声明为abstract的基本操作都是需要迫使子类去实现的，它们仅仅是为模板方法服务的。它们不应该被抽象类（AbstractClass）所公开，所以它们应该protected。</p>
<p>因此模板方法模式中，迫使子类实现的抽象方法应该声明为protected abstract。</p></blockquote>
<blockquote><p>4）模板方法与勾子方法(hookMethod)</p>
<p>模板方法模式的抽象类定义方法：</p>
<p><strong>模板方法：</strong>一个模板方法是定义在抽象类中的、把基本操作方法组合在一起形成一个总算法或一个总行为的方法。</p>
<p><strong>基本方法：</strong>基本方法是实现算法各个步骤的方法，是模板方法的组成部分。<strong>基本方法如下：</strong></p>
<p><strong>&bull;</strong>抽象方法(Abstract Method)</p>
<p>&bull;具体方法(Concrete Method)</p>
<p>&bull;钩子方法(Hook Method)：&ldquo;挂钩&rdquo;方法和空方法，</p>
<p>hook方法在抽象类中的实现为空，是留给子类做一些可选的操作。如果某个子类需要一些特殊额外的操作，则可以实现hook方法，当然也可以完全不用理会，因为hook在抽象类中只是空方法而已。</p>
<p>1）钩子方法的引入使得子类可以控制父类的行为。</p>
<p>2）最简单的钩子方法就是空方法，也可以在钩子方法中定义一个默认的实现，如果子类不覆盖钩子方法，则执行父类的默认实现代码。</p>
<p>3）比较复杂一点的钩子方法可以对其他方法进行约束，这种钩子方法通常返回一个boolean类型，即返回true或false，用来判断是否执行某一个基本方法。由子类来决定是否调用hook方法。</p></blockquote>
<p><strong>11.总结与分析</strong></p>
<blockquote><p>1）模板方法模式是一种类的行为型模式，在它的结构图中只有类之间的继承关系，没有对象关联关系。</p>

<p>2）板方法模式是基于继承的代码复用基本技术，模板方法模式的结构和用法也是面向对象设计的核心之一。在模板方法模式中，可以将相同的代码放在父类中，而将不同的方法实现放在不同的子类中。</p>
<p>3）在模板方法模式中，我们需要准备一个抽象类，将部分逻辑以具体方法以及具体构造函数的形式实现，然后声明一些抽象方法来让子类实现剩余的逻辑。不同的子类可以以不同的方式实现这些抽象方法，从而对剩余的逻辑有不同的实现，这就是模板方法模式的用意。模板方法模式体现了面向对象的诸多重要思想，是一种使用频率较高的模式。</p></blockquote>
<p><P>设计模式 ( 二十 )： Template method模板方法模式 -- 行为型</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-23 12:31:33 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/%e9%97%ae%e9%a2%98/" title="问题">问题</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.biecuoliao.com/tag/art/" title="art">art</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>设计模式 ( 二十 )： Template method模板方法模式 -- 行为型的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j8KPD4.html" rel="bookmark">设计模式13：Template Method 模板方法模式（行为型模式）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Template Method 模板方法模式(行为型模式) 变与不变 变化——是软件永恒的主题,如何管理变化带来的复杂性?设计模式的艺术性和复杂度就在于如何分析,并发现体系中的变化点和稳定点,并使用特定的设计方法来应对这种变化. 动机(Motivation) 在软件构建过程中,对于某一项任务,它常常有稳定的整体操作结构,但各个子步骤却有很多改变的需求,或者由于固定的原因(比如框架与应用之间的关系)而无法和任务的整体结构同时实现. 如何在确定稳定操作结构的前提下,来灵活应对各个子步骤的变化或者晚期			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoomlnM.html" rel="bookmark">设计模式 &lpar; 二十一 &rpar;：Vistor访问者模式 -- 行为型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.概述 在软件开发过程中,对于系统中的某些对象,它们存储在同一个集合collection中,且具有不同的类型,而且对于该集合中的对象,可以接受一类称为访问者的对象来访问,而且不同的访问者其访问方式有所不同. 例子1:顾客在超市中将选择的商品,如苹果.图书等放在购物车中,然后到收银员处付款.在购物过程中,顾客需要对这些商品进行访问,以便确认这些商品的质量,之后收银员计算价格时也需要访问购物车内顾客所选择的商品. 此时,购物车作为一个ObjectStructure(对象结构)用于存储各种类型的商品			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p9zWVM.html" rel="bookmark">设计模式（十五）模板方法模式（Template Method）-行为型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有很多个方法,在多个地方都会用到,为了减少多次重复的操作,选择模板方法模式将这些方法聚在一起做成一个模板形式,从而减少客户端的代码复杂度.实现原理图如下: 模板方法模式实现原理图 抽象的骨架类的示意代码如下: public abstract class Template { public void doSalary(){ operation1(); operation2 (); operation3 (); } public abstract void operation1(); public			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02XVkB4.html" rel="bookmark">设计模式（八）the Template method 模板方法模式（类行为型）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.概述 在面向对象开发过程中,通常我们会遇到这样的一个问题:我们知道一个算法所需的关键步骤,并确定了这些步骤的执行顺序.但是某些步骤的具体实现是未知的,或者说某些步骤的实现与具体的环境相关. 例子1:银行业务办理流程 在银行办理业务时,一般都包含几个基本固定步骤: 取号排队-&gt;办理具体业务-&gt;对银行工作人员进行评分. 取号取号排队和对银行工作人员进行评分业务逻辑是一样的.但是办理具体业务是个不相同的,具体业务可能取款.存款或者转账. 2.问题 如何保证架构逻辑的正常执行,而不被子类破坏 ?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ko79b0.html" rel="bookmark">Template Method &lpar;模板方法模式&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				要想实现 模板方法模式,涉及到两个角色:1.抽象模板角色---父类(抽象的) 2.具体模板角色---子类 就是父类和子类继承的表现 抽象模板角色这个类里 定义了几个抽象方法,供子类去实现具体操作,还定义了一个模板方法(template),以告诉子类去实现这些方法要有一定的顺序去执行, 这种设计模式在JUnit中的setUp(),runTest(),tearDown()体现了, 源码: public void runBare() throws Throwable { setUp(); try {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dYo1n3.html" rel="bookmark">设计模式（十八）---模板方法模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.简介 模板方法模式是类的行为模式.准备一个抽象类,将部分逻辑以具体方法以及具体构造函数的形式实现,然后声明一些抽象方法来迫使子类实现剩余的逻辑. 不同的子类可以以不同的方式实现这些抽象方法,从而对剩余的逻辑有不同的实现.这就是模板方法模式的用意. 2.模板方法结构 模板方法模式是所有模式中最为常见的几个模式之一,是基于继承的代码复用的基本技术. 代表这些具体逻辑步骤的方法称做基本方法(primitive method):而将这些基本方法汇总起来的方法叫做模板方法(template metho			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KjmerM.html" rel="bookmark">设计模式（十）：模板方法模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述 模板方法模式在一个方法中定义一个算法的骨架,而将一些步骤延迟到子类中.模板方法使得子类可以在不改变算法结构的情况下,重新定义算法中的某些步骤. 二.结构类图 三.解决问题 模板方法就是提供一个算法框架,框架里面的步骤有些是父类已经定好的,有些需要子类自己实现.相当于要去办一件事情,行动的流程已经定好了,但有些步骤需要自己去做,而有些步骤可能别人帮我们做了.就拿建网站来说,一般的程序是购买域名--&gt;购买空间--&gt;上传网站--&gt;备案--&gt;审核,每个网站的创建必须经过这样的固定			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/w3vyrX0.html" rel="bookmark">设计模式的征途&mdash;17&period;模板方法（Template Method）模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在现实生活中,很多事情都需要经过几个步骤才能完成,例如请客吃饭,无论吃什么,一般都包含:点单.吃东西.买单等几个步骤,通常情况下这几个步骤的次序是:点单=&gt;吃东西=&gt;买单.在这3个步骤中,点单和买单大同小异,最大的区别在于第2步-吃什么?吃面条和吃满汉全席可大不相同. 在软件开发中,有时候也会遇到类似的情况,某个方法的实现需要多个步骤(类似于“请客”),其中有些步骤是固定的,而有些步骤则存在可变性.为了提高代码复用性和系统灵活性,可以使用一种称之为模板方法模式的设计模式来对这类情况进行设计.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXlxG8M.html" rel="bookmark">设计模式之第3章-模板方法模式&lpar;Java实现&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计模式之第3章-模板方法模式(Java实现) &quot;那个,上次由于我老婆要给我做饭,所以就没有说完就走掉了...这个那个&quot;.这次和以前一样,先来开场福利(工厂方法模式已被作者踹下场).由美女抽象工厂介绍一下适用场景~大家欢迎 抽象工厂之应用场景 一个系统要独立于它的产品的创建.组合和表示时. 一个系统要由多个产品系列中的一个来配置时. 当你要强调一系列相关的产品对象的设计以便进行联合使用时. 当你提供一个产品类库,而只想显示它们的接口而不是实现时. “人家要讲的就这么多了,接下来还是让今			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBmj6J4.html" rel="bookmark" class="title">我眼中的Angular JS</a>
					<div>
						优点:1. 模板功能强大丰富,并且是声明式的,自带了丰富的Angular指令:2. 是一个比较完善的前端MVC框架,包含模板,数据双向绑定,路由,模块化,服务,过滤器,依赖注入等所有功能:3. 自定义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35VYOv4.html" rel="bookmark" class="title">自写atoi----字符串转化为整形</a>
					<div>
						字符串转化为整形的各类情况: char *str1 = &quot;12345&quot;;       //普通 char *str2 = &quot;+12345&quot;;     //正数  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412LAGM.html" rel="bookmark" class="title">VS2017新建windows控制台程序打印中文乱码问题</a>
					<div>
						最近刚换上VS2017,由于手头又要做个MFC的程序,所以写控制台程序做功能测试,然后发现居然乱码了. 于是用VS2017新建windows控制台应用程序,在main函数种加一句printf(&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YgbOO4.html" rel="bookmark" class="title">python&lowbar;day10 多线程 协程 IO模型</a>
					<div>
						多线程协程IO模型 多线程 #线程的PID与主进程PID一致 from threading import Thread from multiprocessing import Process impo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYpJD3.html" rel="bookmark" class="title">bcprovider问题</a>
					<div>
						2015年11月2日昨天我看日志,28号和27号的certid是正常的,而29号的certid是另外一个,我认为是证书被换过了.并且咨询银联之后,银联说相同的证书在不同的操作系统,不同版本的jdk下读 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l51kP3.html" rel="bookmark" class="title">从运营商小广告到HTTPS</a>
					<div>
						相信很多人都试过这样的经历,浏览一个正常的网站时,右下突然角弹出一堆小广告,而且这些广告的内容和你浏览的网站格格不入: 前几天还有某微博用户爆料访问github时居然也有广告: 又或者,你有没有试过因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvq5l3.html" rel="bookmark" class="title">WEB 前端</a>
					<div>
						HTML+CSS+JS html5,css3,jquery MVC:Model+CSS控制样式(View)+JavaScript负责调度数据和实现某种展现逻辑(Controller) Ajax,XML ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415PRq4.html" rel="bookmark" class="title">Object类详解</a>
					<div>
						相等性比较 == 1)对于原生数据类型来说,比较的是左右两边的值是否相等 2)对于引用类型来说,比较左后两边的引用是否指向同一个对象,或者说左右两边的引用地址是否相同. java.lang.Objec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGaYyb3.html" rel="bookmark" class="title">php使用X-SendFile头加速文件下载</a>
					<div>
						在PHP中让文件下载更快的一个方法,那就是使用X-SendFile头实现,主流量的服务器都支持这个头文件. 一般来说, 可以通过直接让URL指向一个位于Document Root下面的文件, 来引导用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrp8n4.html" rel="bookmark" class="title">WPF 数据绑定&comma;界面刷新的两种方法-----INotifyPropertyChanged</a>
					<div>
						.Netformwork4.0及以下版本 -------INotifyPropertyChanged 命名空间: System.ComponentModel 后台代码 public partial c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWbnPM.html" rel="bookmark" class="title">洛谷OJ 1387</a>
					<div>
						https://www.luogu.org/problem/show?pid=1387 在一个n*m的只包含0和1的矩阵里找出一个不包含0的最大正方形,输出边长. n,m&lt;=1e2; 枚举上下边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLP96EM.html" rel="bookmark" class="title">（T&period;T） &amp;nbsp&semi;  &amp;nbsp&semi;   打印100到200之间的素数</a>
					<div>
						#include&lt;stdio.h&gt; #include&lt;math.h&gt; int main() { int m, k, i, n=0; for(m=100; m &lt;= 200 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZN6qZ3.html" rel="bookmark" class="title">iOS动态性：动态添加属性的方法&mdash;&mdash;关联&lpar;e&period;g&period; 向Category添加属性&rpar;</a>
					<div>
						想到要如何为所有的对象增加实例变量吗?我们知道,使用Category可以很方便地为现有的类增加方法,但却无法直接增加实例变量.不过从Mac OS X v10.6开始,系统提供了Associative  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3On1NX0.html" rel="bookmark" class="title">阿萨德21344vsdsdf戚薇出柜</a>
					<div>
						http://travel.tianya.cn/travelPlan/showPlan?planId=4398084 http://travel.tianya.cn/travelPlan/showPl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qjk8QM.html" rel="bookmark" class="title">高效Java编程工具集锦</a>
					<div>
						Java 开发者常常都会想办法如何更快地编写 Java 代码,让编程变得更加轻松.目前,市面上涌现出越来越多的高效编程工具.所以,以下总结了一系列工具列表,其中包含了大多数开发人员已经使用.正在使用或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJWQP3.html" rel="bookmark" class="title">9&period;25  JS&bsol;练习题</a>
					<div>
						题一.左侧菜单下拉 做题思路:先做菜单和子菜单,把子菜单默认隐藏.再用JS调样式. &lt;style type=&quot;text/css&quot;&gt;*{ margin:0px auto; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02XOBz4.html" rel="bookmark" class="title">问题集录02--文件上传（可跨域）</a>
					<div>
						之前工作中遇到了表单跨域上传的问题,寻觅了挺久,才找到解决方法,在此记录. 一.使用from表单上传 工作原理:直接表单提交,访问ssc_media的对应接口 架构说明:使用的是SpringBoot微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xepKB3.html" rel="bookmark" class="title">列表功能</a>
					<div>
						out = ['play','wom','nuw','获取指定元素索引位置'] out.append('追加') print(out) t = out.count('元素出现的次数') print(t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEnGg3.html" rel="bookmark" class="title">DHCP服务器导入地址</a>
					<div>
						1:使用netsh命令导出dhcp服务器已有的地址为文本文件netsh dhcp server 192.168.2.222 scope 192.168.2.0 dump &gt; c:\dhcpd.t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myn8be0.html" rel="bookmark" class="title">Python之JSON序列</a>
					<div>
						Json 不同平台(一般是不同的语言)之间进行数据交换 vim day6-1.py #!/usr/bin/python # -*- coding:utf-8 -*- import json name  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
